<script setup lang="ts">

import { onMounted, ref } from 'vue';
import { storeToRefs } from 'pinia';
import { usePromoStore } from '@/stores/promo';
import { useRoute, useRouter } from 'vue-router';
import StudentList from '@/components/RandomizedStudent.vue';
import { useBookingStore } from '@/stores/booking';
import dayjs from 'dayjs';
import type { Promo } from '@/entities';


const selectedPromo = ref<number>();
const tableCount = ref(localStorage.getItem('tableCount') ? Number(localStorage.getItem('tableCount')):4);

const storeBooking = useBookingStore();
const { bookings } = storeToRefs(storeBooking);
const foundPromo = ref(false);
const promos = ref<Promo[]>([]);
const route = useRoute();
const router = useRouter();


selectedPromo.value = Number(route.query.promo);

function updateRoute() {
  router.replace({ path: '/placing', query: { promo: selectedPromo.value } });
}

function handleCountChange() {
  localStorage.setItem('tableCount', String(tableCount.value));
}


onMounted(async () => {
  await storeBooking.fetchBookings(dayjs().startOf('week').toDate(), dayjs().endOf('week').toDate());
  let list: Promo[] = [];
  for (let booking of bookings.value) {
    if (booking.promo?.id && !list.find(item => item.id == booking.promo!.id)) {
      list.push(booking.promo);
      if (booking.promo.id == selectedPromo.value) {
        foundPromo.value = true;
      }
    }
  }
  promos.value = list;

  if (!selectedPromo.value && promos.value.length > 0) {
    foundPromo.value = true;
    selectedPromo.value = promos.value[0].id;
    updateRoute();
  }
});
</script>
  
<template>
  <el-select v-if="promos.length > 0" v-model="selectedPromo" @change="updateRoute">
    <el-option v-for="promo of promos" :key="promo.id" :label="promo.name" :value="promo.id!"></el-option>

  </el-select>
  <div v-if="foundPromo">
    <label  for="tableCount">Nombre de tables : </label>
    <el-input-number v-model="tableCount" id="tableCount" @change="handleCountChange"></el-input-number>
  </div>
  <p v-if="promos.length == 0">Pas de promo cette semaine</p>
  <p v-if="promos.length > 0 && !foundPromo">La promo entrée en barre d'adresse n'est pas présente cette semaine</p>

  <StudentList class="list" v-if="foundPromo && selectedPromo" :table-count="tableCount" :promo="selectedPromo">
  </StudentList>
</template>

<style scoped>
.list {
  margin-top: 10px;
}
label {
  display: block;
  margin-top: 3px;
  font-size: 0.8em;
}
</style>